<template>
  <router-view v-slot="slotProps">
    <transition name="fade-button" mode="out-in">
      <component :is="slotProps.Component"></component>
    </transition>
  </router-view>

  <!-- <div class="container">
    <users-list></users-list>
  </div>
  <div class="container">
    <div class="block" :class="{ animate: animatedBlock }"></div>
    <button @click="animateBlock">Animate</button>
  </div>
  <div class="container">
    <transition
      :css="false"
      @before-enter="beforeEnter"
      @enter="enter"
      @after-enter="afterEnter"
      @before-leave="beforeLeave"
      @leave="leave"
      @after-leave="afterLeave"
      @enter-cancelled="enterCancelled"
      @leave-cancelled="leaveCancelled"
    > -->
  <!-- <transition name="paragraph"> -->
  <!-- <transition
      enter-to-class="custom-enter-to-class"
      enter-active-class="custom-active-class"
    > -->
  <!-- transition must have only one direct child! -->
  <!-- <p v-if="paragraphIsVisible">This is sometimes visible...</p>
    </transition>
    <button @click="toggleParagraph">Toggle Paragraph</button>
  </div>
  <div class="container">
    <transition name="fade-button" mode="out-in">
      <button @click="showUsers" v-if="!usersAreVisible">Show Users</button>
      <button @click="hideUsers" v-else>Hide Users</button>
    </transition>
  </div>
  <base-modal @close="hideDialog" :open="dialogIsVisible">
    <p>This is a test dialog!</p>
    <button @click="hideDialog">Close it!</button>
  </base-modal>
  <div class="container">
    <button @click="showDialog">Show Dialog</button>
  </div> -->
</template>

<script>
// import UsersList from './components/UsersList.vue';

export default {
  // components: { UsersList },
  data() {
    return {
      animatedBlock: false,
      dialogIsVisible: false,
      paragraphIsVisible: false,
      usersAreVisible: false,
      enterInterval: null,
      leaveInterval: null,
    };
  },
  methods: {
    showUsers() {
      this.usersAreVisible = true;
    },
    hideUsers() {
      this.usersAreVisible = false;
    },
    toggleParagraph() {
      this.paragraphIsVisible = !this.paragraphIsVisible;
    },
    animateBlock() {
      this.animatedBlock = true;
    },
    showDialog() {
      this.dialogIsVisible = true;
    },
    hideDialog() {
      this.dialogIsVisible = false;
    },
    beforeEnter(elem) {
      console.log('Before enter');
      console.log(elem);
      elem.style.opacity = 0;
    },
    enter(elem, done) {
      console.log('Enter');
      console.log(elem);
      let round = 1;
      this.enterInterval = setInterval(() => {
        if (round > 100) {
          clearInterval(this.enterInterval);
          done();
        } else {
          elem.style.opacity = round * 0.01;
          round++;
        }
      }, 20);
    },
    afterEnter(elem) {
      console.log('After enter');
      console.log(elem);
    },
    beforeLeave(elem) {
      console.log('Before leave');
      console.log(elem);
      elem.style.opacity = 1;
    },
    leave(elem, done) {
      console.log('Leave');
      console.log(elem);
      let round = 1;
      this.leaveInterval = setInterval(() => {
        if (round > 100) {
          clearInterval(this.leaveInterval);
          done();
        } else {
          elem.style.opacity = 1 - round * 0.01;
          round++;
          console.log(
            'this.leaveInterval this.leaveInterval: ',
            this.leaveInterval,
            round
          );
        }
      }, 20);
    },
    afterLeave(elem) {
      console.log('After leave');
      console.log(elem);
      elem.style.opacity = 0;
    },
    enterCancelled(elem) {
      console.log('Enter cancelled');
      console.log(elem);
      clearInterval(this.enterInterval);
    },
    leaveCancelled(elem) {
      console.log('Leave cancelled');
      console.log(elem);
      clearInterval(this.leaveInterval);
    },
  },
};
</script>

<style>
* {
  box-sizing: border-box;
}
html {
  font-family: sans-serif;
}
body {
  margin: 0;
}
button {
  font: inherit;
  padding: 0.5rem 2rem;
  border: 1px solid #810032;
  border-radius: 30px;
  background-color: #810032;
  color: white;
  cursor: pointer;
}
button:hover,
button:active {
  background-color: #a80b48;
  border-color: #a80b48;
}
.block {
  width: 8rem;
  height: 8rem;
  background-color: #290033;
  margin-bottom: 2rem;
  /* transition: transform 0.3s ease-out; */
}
.container {
  max-width: 40rem;
  margin: 2rem auto;
  display: flex;
  justify-content: center;
  align-items: center;
  flex-direction: column;
  padding: 2rem;
  border: 2px solid #ccc;
  border-radius: 12px;
}
.animate {
  /* transform: translateX(-150px); */
  animation: slide-scale 0.3s ease-out forwards;
}

.v-enter-from {
  opacity: 0;
  transform: translateY(-30px);
}

.v-enter-active {
  transition: all 0.3s ease-out;
}

.v-enter-to {
  opacity: 1;
  transform: translateY(0);
}

.v-leave-from {
  opacity: 1;
  transform: translateY(0);
}

.v-leave-active {
  transition: all 0.3s ease-in;
}

.v-leave-to {
  opacity: 0;
  transform: translateY(+30px);
}

/* .paragraph-enter-active {
  animation: slide-scale 2s ease-out;
}

.paragraph-leave-active {
  animation: slide-scale 0.3s ease-out;
} */

.fade-button-enter-from,
.fade-button-leave-to {
  opacity: 0;
}

.fade-button-enter-active {
  transition: opacity 0.3s ease-out;
}

.fade-button-leave-active {
  transition: opacity 0.3s ease-in;
}

.fade-button-enter-to,
.fade-button-leave-from {
  opacity: 1;
}

.route-enter-from {
}

.route-enter-active {
  animation: slide-scale 0.4s ease-out;
}

.route-enter-to {
}

.route-enter-active {
  animation: slide-scale 0.4s ease-in;
}

@keyframes slide-scale {
  0% {
    transform: translateX(0) scale(1);
  }

  70% {
    transform: translateX(-120px) scale(1.1);
  }

  100% {
    transform: translateX(-150px) scale(1);
  }
}
</style>
